<form [formGroup]="personForm">
  <input type="text" placeholder="Name" formControlName="name"><br/>
  <div *appPrintErrors="personForm.controls['name']"></div>
  <!-- <div *ngIf="!personForm.controls['name'].valid && (personForm.controls['name'].touched || personForm.controls['name'].dirty)">
    Errors for name:
    <span *ngIf="personForm.controls['name'].errors?.['nameAvailable']">name already taken</span>
  </div> -->
  <input type="password" placeholder="Password" formControlName="password"><br/>
  <!-- <div *ngIf="!personForm.controls['password'].valid && (personForm.controls['password'].touched || personForm.controls['password'].dirty)">
    Errors for password:
    <span *ngIf="personForm.controls['password'].errors?.['required']">required fields</span>
    <span *ngIf="personForm.controls['password'].errors?.['minlength']">must be at least 3 characters long</span>
  </div> -->
  <div *appPrintErrors="personForm.controls['password']"></div>
  <input type="date" placeholder="Date of birth" formControlName="dateOfBirth"><br/>
  <div [ngStyle]="{color: 'red'}" *ngIf="!personForm.valid && (personForm.touched || personForm.dirty)">There are validation errors</div>
  <button type="button" (click)="onCancel()">Cancel</button>
  <button type="button" (click)="onSubmit()" [disabled]="!personForm.valid && (personForm.touched || personForm.dirty)">Submit</button>
</form>
